//
// This file contains the definitions of various things...
//

#pragma pack(1)


struct TYCOONMAPARRAY
{
  BYTE elt[256][256];
};



struct TYCOONV1FILEHEADER
{
  BYTE szSaveName[39];
  WORD w;
};


// sizeof(TYCOONV1HEADER) == 299822
struct TYCOONV1HEADER
{
  char a[299822];
};


struct TYCOONV1WORLD
{
  TYCOONV1HEADER ttInfo;
  TYCOONMAPARRAY ttMapA;
  TYCOONMAPARRAY ttMapB;
};


struct TYCOONV2FILEHEADER
{
  BYTE szSaveName[47];
  WORD wCheck;
};


// sizeof(TYCOONV2HEADER) == 487801

struct TYCOONV2HEADER
{
  WORD a;
  BYTE _b[207]; // unknown
  WORD c;
  BYTE _d[401]; // unknown

  // 0x264
  struct {
    WORD c;
    BYTE _b[92];
  } e[70];
  // 0x1c18

  // files.tmp is read into this struct. sometimes only 2000 bytes, sometimes
  // the whole 262144 bytes.
  struct {
    BYTE filesA[2000];
    BYTE filesB[260144];
  } filestmp;

  // 0x44CBA
  BYTE _z[16394]; // unknown

  // 0x48CBA
  struct {
    BYTE a[142];
  } l[250];

  // 0x51766
  BYTE _z2[59546+65536+16384+11718];

  // 0x76DC6
  WORD  d0;
  WORD  d1;
  WORD  d3;

  BYTE _z3[812];

  // 0x770F8
  BYTE  e0;
  BYTE  e1;
  BYTE  _e2; // unknown
  WORD  e3;
  BYTE  _ze[14];
  BYTE  e10;
  BYTE  _ze2[109];

};

struct TYCOONV2WORLD
{
  TYCOONV2HEADER ttInfo;
  TYCOONMAPARRAY ttMapA;
  TYCOONMAPARRAY ttMapB;
};


// These are the options that ttd modifies
// to make the game easy, medium, or hard.
//
struct TYCOONV2OPTIONS
{
  WORD a;
  WORD b;
  WORD c;
  WORD d;
  WORD e;
  WORD f;
  WORD g;
  WORD h;
  WORD i;
  WORD j;
  WORD k;
  WORD l;
  WORD m;
  WORD n;
  WORD o;
  WORD p;
  WORD q;
};

struct TYCOONV2OPTDAT
{
  TYCOONV2OPTIONS opt;
  WORD w;
  BYTE z;
};

#pragma pack()
